//+------------------------------------------------------------------+
//|                                                 NightScalper.mq5 |
//|                                              Copyright 2016, AM2 | 
//|                                     https://www.forexsystems.biz | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright 2016, AM2" 
#property link "https://www.forexsystems.biz" 
#property version "1.00" 

enum enPairs
  {
   ALL,
   EURGBP,
   EURUSD
  };

#include <Trade\Trade.mqh>                 // Use CTrade Class

input enPairs         tradePairs=ALL;       // Trade pairs

//input string Symbol1     = "USDCAD";       // Symbol1 Name
input int    TakeProfit1 = 20;             // TakeProfit1
input int    BBPeriod1   = 40;             // Bands Period1
input double BBDev1      = 1;              // Bands Deviation1
input double Razmah1     = 450;            // Bands Deviation1 in Points
input int    Start1      = 19;             // Start Time1

//input string Symbol2     = "GBPUSD";       // Symbol2 Name
input int    TakeProfit2 = 80;             // TakeProfit2
input int    BBPeriod2   = 8;              // Bands Period2
input double BBDev2      = 1;              // Bands Deviation2
input double Razmah2     = 200;            // Bands Deviation2 in Points
input int    Start2      = 20;             // Start Time2


input double Lot         = 0.1;              // Trade Volume

int BBHandle=0,bars=0;
double up[1],dn[1],initialBalance,withdrawalTotal;
CTrade trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   initialBalance=AccountInfoDouble(ACCOUNT_BALANCE);
   withdrawalTotal=0;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Count Trades on Symbol                                           |
//+------------------------------------------------------------------+
int CountTrades(string Symb)
  {
   int count=0;
   for(int i=PositionsTotal()-1;i>=0;i--)
     {
      if(PositionGetSymbol(i)==Symb)
        {
         if(PositionGetInteger(POSITION_TYPE)<2) count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|    Symbols Trade Function                                        |
//+------------------------------------------------------------------+
void SymbolTrade(string symb,int stop,int take,int per,double dev,double razmah,int start)
  {
   string s=(string)start+":00";
   double Ask=SymbolInfoDouble(symb,SYMBOL_ASK);
   double Bid=SymbolInfoDouble(symb,SYMBOL_BID);

   BBHandle=iBands(symb,0,per,0,dev,0);
   CopyBuffer(BBHandle,1,0,1,up);
   CopyBuffer(BBHandle,2,0,1,dn);

   double r=up[0]-dn[0];
   if(Ask<dn[0] && r<razmah*_Point) trade.PositionOpen(symb,0,Lot,Ask,0,Ask+take*_Point);
   if(Bid>up[0] && r<razmah*_Point) trade.PositionOpen(symb,1,Lot,Bid,0,Bid-take*_Point);

  }
//+------------------------------------------------------------------+
//|    Close All Positions on Symbol                                 |
//+------------------------------------------------------------------+
void CloseAll(string Symb)
  {
   for(int i=PositionsTotal()-1;i>=0;i--)
     {
      if(PositionGetSymbol(i)==Symb)
        {
         if(PositionGetInteger(POSITION_TYPE)<2) trade.PositionClose(Symb);
        }
     }
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

   if(bars!=Bars(NULL,0))
     {
     
      double balance=AccountInfoDouble(ACCOUNT_BALANCE);
      if(balance>initialBalance)
        {
         double withdrawal=balance-initialBalance;
         if(TesterWithdrawal(balance-initialBalance))
           {
            withdrawalTotal=withdrawalTotal+withdrawal;
            Print("Total withdrawn: ",DoubleToString(withdrawalTotal,2));
           }
        }
        
      switch (tradePairs) {
        case ALL:
          SymbolTrade("EURGBP",0,TakeProfit1,BBPeriod1,BBDev1,Razmah1,Start1);
          SymbolTrade("EURUSD",0,TakeProfit2,BBPeriod2,BBDev2,Razmah2,Start2);
        break;
        case EURGBP:
          SymbolTrade("EURGBP",0,TakeProfit1,BBPeriod1,BBDev1,Razmah1,Start1);
        break;
        case EURUSD:
          SymbolTrade("EURUSD",0,TakeProfit2,BBPeriod2,BBDev2,Razmah2,Start2);
        break;
      }

     }
   bars=Bars(NULL,0);
  }
//+------------------------------------------------------------------+
